from __future__ import annotations

from collections.abc import Mapping
from typing import TYPE_CHECKING, Any, TypeVar

from attrs import define as _attrs_define
from attrs import field as _attrs_field

from ..types import UNSET, Unset

if TYPE_CHECKING:
    from ..models.types_employee_census_check_error import TypesEmployeeCensusCheckError


T = TypeVar("T", bound="TypesEmployeeCensusIssue")


@_attrs_define
class TypesEmployeeCensusIssue:
    """
    Attributes:
        employee (str | Unset):
        errors (list[TypesEmployeeCensusCheckError] | Unset):
    """

    employee: str | Unset = UNSET
    errors: list[TypesEmployeeCensusCheckError] | Unset = UNSET
    additional_properties: dict[str, Any] = _attrs_field(init=False, factory=dict)

    def to_dict(self) -> dict[str, Any]:
        employee = self.employee

        errors: list[dict[str, Any]] | Unset = UNSET
        if not isinstance(self.errors, Unset):
            errors = []
            for errors_item_data in self.errors:
                errors_item = errors_item_data.to_dict()
                errors.append(errors_item)

        field_dict: dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({})
        if employee is not UNSET:
            field_dict["employee"] = employee
        if errors is not UNSET:
            field_dict["errors"] = errors

        return field_dict

    @classmethod
    def from_dict(cls: type[T], src_dict: Mapping[str, Any]) -> T:
        from ..models.types_employee_census_check_error import TypesEmployeeCensusCheckError

        d = dict(src_dict)
        employee = d.pop("employee", UNSET)

        _errors = d.pop("errors", UNSET)
        errors: list[TypesEmployeeCensusCheckError] | Unset = UNSET
        if _errors is not UNSET:
            errors = []
            for errors_item_data in _errors:
                errors_item = TypesEmployeeCensusCheckError.from_dict(errors_item_data)

                errors.append(errors_item)

        types_employee_census_issue = cls(
            employee=employee,
            errors=errors,
        )

        types_employee_census_issue.additional_properties = d
        return types_employee_census_issue

    @property
    def additional_keys(self) -> list[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
